# $Id: setup.pl,v 1.4 2006/12/23 17:46:17 koba Exp $
#	Copyright(c) 2006 Satoshi Kobayashi, All rights reserved.

my $install = '/usr/local/xiumai';

chomp(my $perl_path = `which perl`);
$perl_path .= ' -Tw';

$install = shift @ARGV	if @ARGV;

{
	my $file = 'lib/XiuMai.pm';
	my $orig = "$file.orig";
	system('cp', '-p', $file, $orig) == 0	or die;

	open(NEW, ">$file")	or die "$file: $!\n";
	open(OLD, $orig)	or die "$orig: $!\n";
	while (<OLD>) {
		s/'.*'/'$install'/	if (/^\$INSTALL\b/);
		print NEW $_;
	}
	close(OLD);
	close(NEW);

	unlink($orig);
}

my @file = qw(
	cgi-bin/xiumai.cgi
);

foreach my $file (@file) {

	my $orig = "$file.orig";
	system('cp', '-p', $file, $orig) == 0	or die;

	open(NEW, ">$file")	or die "$file: $!\n";
	open(OLD, $orig)	or die "$orig: $!\n";
	$_ = <OLD>;
	s/^#!.*/#!$perl_path/;
	print NEW $_;
	while (<OLD>) {
		s|^use lib '.*'|use lib '$install/lib'|;
		s|^\$XiuMai::HOME = '.*'|\$XiuMai::HOME = '$install'|;
		print NEW $_
	}
	close(OLD);
	close(NEW);

	unlink($orig);
}

my $lang = $ENV{LANG} || 'ja';
$lang =~ s/\..*$//;
$lang =~ s/_/-/g;
$lang = lc($lang);

my $default_locale = "locale/message";
unlink($default_locale);
if (-f "$default_locale.$lang") {
	symlink("message.$lang", $default_locale);
}
while ($lang =~ s/-.+?$//) {
	if (-f "$default_locale.$lang") {
		symlink("message.$lang", $default_locale);
	}
}

print $install;
